<?php
// returns an URL where to find a file specified by its actual filesystem path
// It'll cache the file. And use the tmp_web_path to create the file at the
// URL returned.
function b_url($path)
{
  global $cache_path,$tmp_web_path, $tmp_web_url;

  if ($path === false)
    return(false);

  //echo "<BR>received path : '$path'";

  $basename=basename($path);
  $md5=md5_file($path);
  $cache_name= $cache_path . "/b_url_" . $md5 . ".cache";

  // file is cached ?
  if (!file_exists($cache_name))
    {
      // TODO : a simplyier copy file ? or link ?
      file_set_contents($cache_name, file_get_contents($path));
    };


  // build link to cache in dummy.
  if (!is_dir("$tmp_web_path/img"))
    mkdir("$tmp_web_path/img");

  $dummy_name="$tmp_web_path/img/$basename";
  $dummy_url="$tmp_web_url/img/$basename";
  $exists=file_exists($dummy_name);
    
  if ((!($exists)) || (md5_file($dummy_name) != $md5))
    {
      ($exists) && unlink($dummy_name);
      build_dummy_file($dummy_name,$cache_name);
    };


  //  echo "<BR>received path : '$path'";
  //  echo "<BR>returning : '$dummy_url'";

  return($dummy_url);
};

// must create a shadow file of "$filename"
function build_dummy_file($dummy_name, $file_name)
{
  // For now, do a simple link.
  //  echo "creating : '$dummy_name'";
  system("cp  \"" . $file_name . "\" \"" . $dummy_name . "\"");

};

?>