<?php

include_once("PEAR.php");

// TODO : replace the 2 file_*_contents by the normal ones...

if(!function_exists('file_get_contents')) {
  function file_get_contents($filename, $use_include_path = 0)
    {
      $fd = fopen ($filename, "rb", $use_include_path);
      $contents = fread($fd, filesize($filename));
      fclose($fd);
      return $contents;
    }
}

if(!function_exists('file_set_contents')) {
  function file_set_contents($filename, $content)
    {
      $fd = fopen ($filename, "w+b");
      fwrite($fd, "$content");
      fclose($fd);
    }
};

function file_path($name, $include_paths)
{

  $paths[]=".";
  $paths=array_merge($paths,$include_paths);


  reset($paths);
  while(list (,$val) = each($paths))
    {
      //      logstr("checking : '" . $val . "/" . $name ."'");
      if (file_exists($val . "/" . $name))
	{
	  //	  logstr("found file:");
	  return($val . "/" . $name);
	};
      
      
    };
  
  //  logstr("NOT found file: ");
  return(false);

}

function file_in_PATH($name) {
  return(file_path($name, explode(":", $_ENV["PATH"])));
}

function file_var_complete() {

  foreach($GLOBALS as $k=>$v) {
    
    if ((substr($k,-4) == "_bin") &&
        (!file_exists($v))) {
      //echo "Correcting path...";
      $GLOBALS[$k] = file_in_PATH(substr($k,0,-4));
      //echo "$k is " . file_in_PATH(substr($k,0,-4));
    };

  };
  //exit(1);
  return(true);
}




class File extends PEAR {
  
  var $path;

  function File($path)
    {
      if (!file_exist($path))
	{
	  raiseError("'$path' is not a valid path file");
	  return;
	};

      $this->path = $path;

      return;
    }

  function getContent()
    {
      return(file_get_content($path));
    }

  function putContent($data)
    {
      return(file_set_contents($path,$data));
    }

}


// Take a dir name.
// Returns filenames in an array.
function list_file($rep)
{
  $handle = opendir($rep);
  while ( $file = readdir($handle) )
    {
      $files[] = $file;
    }
  closedir($handle);
  return($files);
};

// Take a dir name
// Returns subdirs in an array (without '.' and '..') (sorted)
function list_gal($rep)
{
  $pre_array=list_file($rep);
  $array=array();
  
  sort($pre_array);
  reset($pre_array);
  while (list ($key, $val) = each ($pre_array))
    {
      if (is_dir("$rep/$val") && ($val != ".") && ($val != ".."))
	{
	  $array[]=$val;
	};
    };
  return($array);
};

// Take a dir name
// Returns JPG files in an array (sorted).
function list_img($rep)
{
  $pre_array=list_file($rep);
  $array=array();
  
  sort($pre_array);
  reset($pre_array);
  while (list ($key, $val) = each ($pre_array))
    {
      if (file_exists("$rep/$val") && (strcasecmp(substr($val,strlen($val)-4),".jpg") == 0))
	{
	  $array[]=$val;
	};
    };
  return($array);
};

// Take a filename and a dir name...
// Returns filename of preceeding image file as if sorted with list_img.
function last_img($file,$rep)
{
  $ar=list_img($rep);

  return($ar[array_search($file,$ar) - 1 ]);
};

// Take a filename and a dir name...
// Returns filename of next image file as if sorted with list_img.
function next_img($file,$rep)
{
  $ar=list_img($rep);

  return($ar[array_search($file,$ar) + 1 ]);
};

file_var_complete();



?>