<?php

// TODO : autoconf most of these...
/*
  We could auto configure lots of these.

*/

# ==================================================
# MANDATORY OPTIONS
# ==================================================

# base_rep must point on the picture directory to be served.
# This is the only option that MUST be set correctly.
# base_rep will be considered as root directory of galleries.
# base_rep must be directory path in your filesystem standard,
# it can be in or out from your web browseable directory 
# structure. (In fact, it is somewhat cleaner that your pictures 
# directory was located outside your web browseable directory
# tree.)

$base_rep="/usr/share/Media/multimedia/Images";
 
# This is the title of all pages
$phpview_title = "PHP Viewer"

# ==================================================
# OPTIONS
# ==================================================

# This is where to link the back button when on top of the
# gallerie tree. This is usefull if the gallery is part
# of a wider web site.
# You can put here the url you want.

$main_page="/"; 

# This is default langages for all the generated text
# Currently, phpview supports only english "en", or
# french "fr"
#
#$default_lang="fr";

$default_lang="en";

# === Viewing gallery Options

# Number of thumb displayed by page in gallery mode.
# gallery mode shows pictures as thumbnail. 

$thumb_by_page=10;

# These are thumbs dimensions : 
# SquareMin and SquareMax are the size limit of thumbnail.
# SquareMin is size of a square in pixels that will fit IN any thumbnail.
# SquareMax is size of a square in pixels in which any thumbnail will fit.

$SquareMin=40; 
$SquareMax=180;

# Between SquareMin and SquareMax, resize to how much percent of 
# normal size ?

$Percent=10;  

# === Image Qualities

# resolutions can be added conveniently here.
# These are the different picture's resolutions which will
# be computed and proposed to see and download.
# To add a new resolution : add line as : 
#
# $resolution["label"]="123x456";

$resolution["low"]="640x480";
$resolution["mid"]="1024x768";
#$resolution["mid2"]="1280x1024";
$resolution["high"]="1600x1200";

# This is the default displayed resolution
# in display image mode.

$default_res="low";

# ==================================================
# AUTOMAGICALLY SET OPTIONS
# ==================================================

# You shouldn't touch these options unless you really now
# what you are doing, or system has been messed up.

# This is location of the system wide configuration file :

$sysconf="%%pkgdatadir%%/sysconf.inc";

?>
